"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const debug_1 = __importDefault(require("debug"));
const rxjs_1 = require("rxjs");
const operators_1 = require("rxjs/operators");
exports.isDefined = (val) => !!val;
exports.debugLog = debug_1.default("friendship-blaster");
exports.promiseFactoryToObservable = (promiseFactory) => rxjs_1.of(undefined).pipe(operators_1.switchMap(promiseFactory));
exports.switchScan = (accumulator, seed) => operators_1.mergeScan(accumulator, seed, 1);
exports.logErrorAndRetry = (logFormat, retryAfterSeconds) => rxjs_1.pipe(operators_1.tap(null, error => {
    console.warn(logFormat, error);
}), operators_1.retryWhen(e => e.pipe(operators_1.delay(retryAfterSeconds))));
exports.observeSignalUSR2 = () => new rxjs_1.Observable(observer => {
    process.on("SIGUSR2", () => {
        observer.next();
    });
});
exports.interruptableInterval = (period) => exports.observeSignalUSR2().pipe(operators_1.mapTo(rxjs_1.merge(rxjs_1.interval(period), rxjs_1.of(-1))), operators_1.startWith(rxjs_1.interval(period)), operators_1.switchAll(), operators_1.map(sequence => sequence < 0));
//# sourceMappingURL=util.js.map